using System;
using System.Collections.Generic;
using System.Text;

using System.Collections;
using System.Drawing;

using Syncfusion.Windows.Forms.Diagram;

namespace SyncfusionTest
{
    class MyLinkSupport
    {
     
        public MyLinkSupport()
		{
			
		}

    public CompassHeading[] CalculateCompassHeadings(Port sourcePort, Port targetPort)
		{
			// TODO: Refactor this. Test this with new NodeSymbol
			Port[] ports = new Port[2] ;
			ports[0] = sourcePort;
			ports[1]= targetPort;

			CompassHeading[] compassHeadings= new CompassHeading[2];
			compassHeadings[0] = CalculateCompassHeading(ports[0]);
			compassHeadings[1] = CalculateCompassHeading(ports[1]);
			
			return compassHeadings;
		}

		public CompassHeading CalculateCompassHeading(Port targetPort)
		{
			// TODO: Refactor this. Test this with new NodeSymbol
			Port port = targetPort as Port;

			CompassHeading compassHeading= new CompassHeading();
			compassHeading = CompassHeading.None;
			
			switch(port.Name)
			{
						
				case "TopPort" :
					compassHeading = CompassHeading.North;
					break;
				case "BottomPort":
					compassHeading = CompassHeading.South; 									
					break;
				case "LeftPort":
					compassHeading = CompassHeading.West;
					break;
				case "RightPort":
					compassHeading = CompassHeading.East;
					break;
			}
			return compassHeading;
		}

        public MyCirclePort GetPortForConnector(MySymbol nodeSymbol, Point terminalPoint)
		{
			if((!IsValueInRange(nodeSymbol.X,terminalPoint.X)) && (!IsValueInRange(nodeSymbol.X+nodeSymbol.Width,terminalPoint.X)))
			{
				if(!IsValueInRange(nodeSymbol.Y, terminalPoint.Y))
				{
					return nodeSymbol.BottomPort;
				}
				else if(!IsValueInRange(nodeSymbol.Y + nodeSymbol.Height, terminalPoint.Y))
				{
					return nodeSymbol.TopPort;
				}
			}
			else if(IsValueInRange(nodeSymbol.X,terminalPoint.X))
			{
				return nodeSymbol.LeftPort;
			}
			else if(IsValueInRange(nodeSymbol.X+nodeSymbol.Width,terminalPoint.X))
			{
				return nodeSymbol.RightPort;
			} 
			return null;
		}

		private bool IsValueInRange(float portLocation,float connectorLocation)
		{
			if((connectorLocation >= (portLocation - 5)) && (connectorLocation <= (portLocation + 5)))
			{
				return true;
			}
			else return false;
		}

        public bool CheckForDuplicateConnections(MySymbol sourceNode, MySymbol targetNode)
		{
			// TODO: Refactor this.

			if(sourceNode == targetNode)
			{
				return false;
			}

			if((sourceNode.Edges.Count > 0) && (targetNode.Edges.Count > 0))
			{
				IEnumerator sourceEdgeEnumerator = sourceNode.Edges.GetEnumerator(); 
				IEnumerator targetEdgeEnumerator = targetNode.Edges.GetEnumerator(); 
					
				while(sourceEdgeEnumerator.MoveNext())
				{	
					targetEdgeEnumerator.Reset();
					while(targetEdgeEnumerator.MoveNext())
					{
						if(sourceEdgeEnumerator.Current == targetEdgeEnumerator.Current)
						{
							return false;
						}
					}
						
				}
				return true;
			}
			else
			{
				return true;
			}
		}
	}
}


